Index: trunk/src/libs/xpcom18a4/nsprpub/pr/include/prprf.h
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/include/prprf.h	(revision 102217)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/include/prprf.h	(revision 102223)
@@ -64,9 +64,5 @@
 #define PR_smprintf VBoxNsprPR_smprintf
 #define PR_smprintf_free VBoxNsprPR_smprintf_free
-#define PR_sprintf_append VBoxNsprPR_sprintf_append
-#define PR_sxprintf VBoxNsprPR_sxprintf
 #define PR_vsmprintf VBoxNsprPR_vsmprintf
-#define PR_vsprintf_append VBoxNsprPR_vsprintf_append
-#define PR_vsxprintf VBoxNsprPR_vsxprintf
 #endif /* VBOX_WITH_XPCOM_NAMESPACE_CLEANUP */
 
@@ -93,30 +89,8 @@
 
 /*
-** "append" sprintf into a PR_MALLOC'd buffer. "last" is the last value of
-** the PR_MALLOC'd buffer. sprintf will append data to the end of last,
-** growing it as necessary using realloc. If last is NULL, PR_sprintf_append
-** will allocate the initial string. The return value is the new value of
-** last for subsequent calls, or NULL if there is a malloc failure.
-*/
-NSPR_API(char*) PR_sprintf_append(char *last, const char *fmt, ...);
-
-/*
-** sprintf into a function. The function "f" is called with a string to
-** place into the output. "arg" is an opaque pointer used by the stuff
-** function to hold any state needed to do the storage of the output
-** data. The return value is a count of the number of characters fed to
-** the stuff function, or (PRUint32)-1 if an error occurs.
-*/
-typedef PRIntn (*PRStuffFunc)(void *arg, const char *s, PRUint32 slen);
-
-NSPR_API(PRUint32) PR_sxprintf(PRStuffFunc f, void *arg, const char *fmt, ...);
-
-/*
 ** va_list forms of the above.
 */
 NSPR_API(PRUint32) PR_vsnprintf(char *out, PRUint32 outlen, const char *fmt, va_list ap);
 NSPR_API(char*) PR_vsmprintf(const char *fmt, va_list ap);
-NSPR_API(char*) PR_vsprintf_append(char *last, const char *fmt, va_list ap);
-NSPR_API(PRUint32) PR_vsxprintf(PRStuffFunc f, void *arg, const char *fmt, va_list ap);
 
 PR_END_EXTERN_C
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/include/prtime.h
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/include/prtime.h	(revision 102217)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/include/prtime.h	(revision 102223)
@@ -53,7 +53,4 @@
 #ifdef VBOX_WITH_XPCOM_NAMESPACE_CLEANUP
 #define PR_Now VBoxNsprPR_Now
-#define PR_ExplodeTime VBoxNsprPR_ExplodeTime
-#define PR_ImplodeTime VBoxNsprPR_ImplodeTime
-#define PR_NormalizeTime VBoxNsprPR_NormalizeTime
 #endif /* VBOX_WITH_XPCOM_NAMESPACE_CLEANUP */
 
@@ -87,82 +84,4 @@
 typedef PRInt64 PRTime;
 
-/*
- * Time zone and daylight saving time corrections applied to GMT to
- * obtain the local time of some geographic location
- */
-
-typedef struct PRTimeParameters {
-    PRInt32 tp_gmt_offset;     /* the offset from GMT in seconds */
-    PRInt32 tp_dst_offset;     /* contribution of DST in seconds */
-} PRTimeParameters;
-
-/*
- * PRExplodedTime --
- *
- *     Time broken down into human-readable components such as year, month,
- *     day, hour, minute, second, and microsecond.  Time zone and daylight
- *     saving time corrections may be applied.  If they are applied, the
- *     offsets from the GMT must be saved in the 'tm_params' field so that
- *     all the information is available to reconstruct GMT.
- *
- *     Notes on porting: PRExplodedTime corrresponds to struct tm in
- *     ANSI C, with the following differences:
- *       - an additional field tm_usec;
- *       - replacing tm_isdst by tm_params;
- *       - the month field is spelled tm_month, not tm_mon;
- *       - we use absolute year, AD, not the year since 1900.
- *     The corresponding type in NSPR 1.0 is called PRTime.  Below is
- *     a table of date/time type correspondence in the three APIs:
- *         API          time since epoch          time in components
- *       ANSI C             time_t                  struct tm
- *       NSPR 1.0           PRInt64                   PRTime
- *       NSPR 2.0           PRTime                  PRExplodedTime
- */
-
-typedef struct PRExplodedTime {
-    PRInt32 tm_usec;		    /* microseconds past tm_sec (0-99999)  */
-    PRInt32 tm_sec;             /* seconds past tm_min (0-61, accomodating
-                                   up to two leap seconds) */	
-    PRInt32 tm_min;             /* minutes past tm_hour (0-59) */
-    PRInt32 tm_hour;            /* hours past tm_day (0-23) */
-    PRInt32 tm_mday;            /* days past tm_mon (1-31, note that it
-				                starts from 1) */
-    PRInt32 tm_month;           /* months past tm_year (0-11, Jan = 0) */
-    PRInt16 tm_year;            /* absolute year, AD (note that we do not
-				                count from 1900) */
-
-    PRInt8 tm_wday;		        /* calculated day of the week
-				                (0-6, Sun = 0) */
-    PRInt16 tm_yday;            /* calculated day of the year 
-				                (0-365, Jan 1 = 0) */
-
-    PRTimeParameters tm_params;  /* time parameters used by conversion */
-} PRExplodedTime;
-
-/*
- * PRTimeParamFn --
- *
- *     A function of PRTimeParamFn type returns the time zone and
- *     daylight saving time corrections for some geographic location,
- *     given the current time in GMT.  The input argument gmt should
- *     point to a PRExplodedTime that is in GMT, i.e., whose
- *     tm_params contains all 0's.
- *
- *     For any time zone other than GMT, the computation is intended to
- *     consist of two steps:
- *       - Figure out the time zone correction, tp_gmt_offset.  This number
- *         usually depends on the geographic location only.  But it may
- *         also depend on the current time.  For example, all of China
- *         is one time zone right now.  But this situation may change
- *         in the future.
- *       - Figure out the daylight saving time correction, tp_dst_offset.
- *         This number depends on both the geographic location and the
- *         current time.  Most of the DST rules are expressed in local
- *         current time.  If so, one should apply the time zone correction
- *         to GMT before applying the DST rules.
- */
-
-typedef PRTimeParameters (PR_CALLBACK *PRTimeParamFn)(const PRExplodedTime *gmt);
-
 /**********************************************************************/
 /****************************** FUNCTIONS *****************************/
@@ -189,40 +108,4 @@
 PR_Now(void);
 
-/*
- * Expand time binding it to time parameters provided by PRTimeParamFn.
- * The calculation is envisoned to proceed in the following steps:
- *   - From given PRTime, calculate PRExplodedTime in GMT
- *   - Apply the given PRTimeParamFn to the GMT that we just calculated
- *     to obtain PRTimeParameters.
- *   - Add the PRTimeParameters offsets to GMT to get the local time
- *     as PRExplodedTime.
- */
-
-NSPR_API(void) PR_ExplodeTime(
-    PRTime usecs, PRTimeParamFn params, PRExplodedTime *exploded);
-
-/* Reverse operation of PR_ExplodeTime */
-#if defined(HAVE_WATCOM_BUG_2)
-PRTime __pascal __export __loadds
-#else
-NSPR_API(PRTime) 
-#endif
-PR_ImplodeTime(const PRExplodedTime *exploded);
-
-/*
- * Adjust exploded time to normalize field overflows after manipulation.
- * Note that the following fields of PRExplodedTime should not be
- * manipulated:
- *   - tm_month and tm_year: because the number of days in a month and
- *     number of days in a year are not constant, it is ambiguous to
- *     manipulate the month and year fields, although one may be tempted
- *     to.  For example, what does "a month from January 31st" mean?
- *   - tm_wday and tm_yday: these fields are calculated by NSPR.  Users
- *     should treat them as "read-only".
- */
-
-NSPR_API(void) PR_NormalizeTime(
-    PRExplodedTime *exploded, PRTimeParamFn params);
-
 PR_END_EXTERN_C
 
Index: trunk/src/libs/xpcom18a4/nsprpub/pr/src/io/prprf.c
===================================================================
--- trunk/src/libs/xpcom18a4/nsprpub/pr/src/io/prprf.c	(revision 102217)
+++ trunk/src/libs/xpcom18a4/nsprpub/pr/src/io/prprf.c	(revision 102223)
@@ -1012,44 +1012,4 @@
 }
 
-/************************************************************************/
-
-static int FuncStuff(SprintfState *ss, const char *sp, PRUint32 len)
-{
-    int rv;
-
-    rv = (*ss->func)(ss->arg, sp, len);
-    if (rv < 0) {
-	return rv;
-    }
-    ss->maxlen += len;
-    return 0;
-}
-
-PR_IMPLEMENT(PRUint32) PR_sxprintf(PRStuffFunc func, void *arg, 
-                                 const char *fmt, ...)
-{
-    va_list ap;
-    PRUint32 rv;
-
-    va_start(ap, fmt);
-    rv = PR_vsxprintf(func, arg, fmt, ap);
-    va_end(ap);
-    return rv;
-}
-
-PR_IMPLEMENT(PRUint32) PR_vsxprintf(PRStuffFunc func, void *arg, 
-                                  const char *fmt, va_list ap)
-{
-    SprintfState ss;
-    int rv;
-
-    ss.stuff = FuncStuff;
-    ss.func = func;
-    ss.arg = arg;
-    ss.maxlen = 0;
-    rv = dosprintf(&ss, fmt, ap);
-    return (rv < 0) ? (PRUint32)-1 : ss.maxlen;
-}
-
 /*
 ** Stuff routine that automatically grows the malloc'd output buffer
@@ -1191,40 +1151,2 @@
     return n ? n - 1 : n;
 }
-
-PR_IMPLEMENT(char *) PR_sprintf_append(char *last, const char *fmt, ...)
-{
-    va_list ap;
-    char *rv;
-
-    va_start(ap, fmt);
-    rv = PR_vsprintf_append(last, fmt, ap);
-    va_end(ap);
-    return rv;
-}
-
-PR_IMPLEMENT(char *) PR_vsprintf_append(char *last, const char *fmt, va_list ap)
-{
-    SprintfState ss;
-    int rv;
-
-    ss.stuff = GrowStuff;
-    if (last) {
-	int lastlen = strlen(last);
-	ss.base = last;
-	ss.cur = last + lastlen;
-	ss.maxlen = lastlen;
-    } else {
-	ss.base = 0;
-	ss.cur = 0;
-	ss.maxlen = 0;
-    }
-    rv = dosprintf(&ss, fmt, ap);
-    if (rv < 0) {
-	if (ss.base) {
-	    PR_DELETE(ss.base);
-	}
-	return 0;
-    }
-    return ss.base;
-}
-