Index: trunk/src/libs/xpcom18a4/Config.kmk
===================================================================
--- trunk/src/libs/xpcom18a4/Config.kmk	(revision 102317)
+++ trunk/src/libs/xpcom18a4/Config.kmk	(revision 102318)
@@ -347,5 +347,4 @@
 	xpcom/io/nsIOutputStream.idl \
 	xpcom/io/nsIStreamBufferAccess.idl \
-	xpcom/io/nsIScriptableInputStream.idl \
 	xpcom/proxy/public/nsIProxyObjectManager.idl \
 	xpcom/threads/nsIEventQueueService.idl \
Index: trunk/src/libs/xpcom18a4/Makefile.kmk
===================================================================
--- trunk/src/libs/xpcom18a4/Makefile.kmk	(revision 102317)
+++ trunk/src/libs/xpcom18a4/Makefile.kmk	(revision 102318)
@@ -253,5 +253,4 @@
 	xpcom/ds/nsQuickSort.h \
 	xpcom/ds/nsRefPtrHashtable.h \
-	xpcom/io/nsScriptableInputStream.h \
 	xpcom/ds/nsStaticAtom.h \
 	xpcom/components/nsStaticComponent.h \
@@ -484,5 +483,4 @@
 	xpcom/io/nsDirectoryService.cpp \
 	xpcom/io/nsLocalFileCommon.cpp \
-	xpcom/io/nsScriptableInputStream.cpp \
 	xpcom/io/SpecialSystemDirectory.cpp \
 	xpcom/io/nsNativeCharsetUtils.cpp
@@ -963,5 +961,4 @@
 		nsIInputStream.xpt \
 		nsIOutputStream.xpt \
-		nsIScriptableInputStream.xpt \
 		nsIComponentLoader.xpt \
 		nsIComponentLoaderManager.xpt \
Index: trunk/src/libs/xpcom18a4/xpcom/build/nsXPComInit.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/build/nsXPComInit.cpp	(revision 102317)
+++ trunk/src/libs/xpcom18a4/xpcom/build/nsXPComInit.cpp	(revision 102318)
@@ -47,5 +47,4 @@
 #include "nsProperties.h"
 #include "nsIProperties.h"
-#include "nsScriptableInputStream.h"
 #include "nsBinaryStream.h"
 
@@ -323,5 +322,4 @@
     COMPONENT(ERRORSERVICE, nsErrorService::Create),
 
-    COMPONENT(SCRIPTABLEINPUTSTREAM, nsScriptableInputStream::Create),
     COMPONENT(BINARYINPUTSTREAM, nsBinaryInputStreamConstructor),
     COMPONENT(BINARYOUTPUTSTREAM, nsBinaryOutputStreamConstructor),
Index: trunk/src/libs/xpcom18a4/xpcom/io/nsIScriptableInputStream.idl
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/io/nsIScriptableInputStream.idl	(revision 102317)
+++ 	(revision )
@@ -1,73 +1,0 @@
-/* -*- Mode: IDL; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is Mozilla Communicator client code, released
- * March 31, 1998.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998-1999
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-#include "nsISupports.idl"
-
-interface nsIInputStream;
-
-/**
- * nsIScriptableInputStream provides scriptable access to the nsIInputStream.  
- *
- * @status FROZEN
- */
-[scriptable, uuid(a2a32f90-9b90-11d3-a189-0050041caf44)] 
-interface nsIScriptableInputStream : nsISupports
-{ 
-    /** 
-     * Closes the stream. 
-     */
-    void close();
-
-    /** Wrap the given nsIInputStream with this nsIScriptableInputStream. 
-     *  @param aInputStream [in] parameter providing the stream to wrap 
-     */ 
-    void init(in nsIInputStream aInputStream); 
-
-    /** Return the number of bytes currently available in the stream 
-     *  @param _retval [out] parameter to hold the number of bytes 
-     *         if an error occurs, the parameter will be undefined 
-     *  @return error status 
-     */ 
-    unsigned long available(); 
-
-    /** Read data from the stream. 
-     *  @param aCount [in] the maximum number of bytes to read 
-     *  @param _retval [out] the data
-     */ 
-    string read(in unsigned long aCount); 
-}; 
Index: trunk/src/libs/xpcom18a4/xpcom/io/nsScriptableInputStream.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/io/nsScriptableInputStream.cpp	(revision 102317)
+++ 	(revision )
@@ -1,102 +1,0 @@
-/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-#include "nsScriptableInputStream.h"
-#include "nsMemory.h"
-
-NS_IMPL_ISUPPORTS1(nsScriptableInputStream, nsIScriptableInputStream)
-
-// nsIBaseStream methods
-NS_IMETHODIMP
-nsScriptableInputStream::Close(void) {
-    if (!mInputStream) return NS_ERROR_NOT_INITIALIZED;
-    return mInputStream->Close();
-}
-
-// nsIScriptableInputStream methods
-NS_IMETHODIMP
-nsScriptableInputStream::Init(nsIInputStream *aInputStream) {
-    if (!aInputStream) return NS_ERROR_NULL_POINTER;
-    mInputStream = aInputStream;
-    return NS_OK;
-}
-
-NS_IMETHODIMP
-nsScriptableInputStream::Available(PRUint32 *_retval) {
-    if (!mInputStream) return NS_ERROR_NOT_INITIALIZED;
-    return mInputStream->Available(_retval);
-}
-
-NS_IMETHODIMP
-nsScriptableInputStream::Read(PRUint32 aCount, char **_retval) {
-    nsresult rv = NS_OK;
-    PRUint32 count = 0;
-    char *buffer = nsnull;
-
-    if (!mInputStream) return NS_ERROR_NOT_INITIALIZED;
-
-    rv = mInputStream->Available(&count);
-    if (NS_FAILED(rv)) return rv;
-
-    count = PR_MIN(count, aCount);
-    buffer = (char*)nsMemory::Alloc(count+1); // make room for '\0'
-    if (!buffer) return NS_ERROR_OUT_OF_MEMORY;
-
-    PRUint32 amtRead = 0;
-    rv = mInputStream->Read(buffer, count, &amtRead);
-    if (NS_FAILED(rv)) {
-        nsMemory::Free(buffer);
-        return rv;
-    }
-
-    buffer[amtRead] = '\0';
-    *_retval = buffer;
-    return NS_OK;
-}
-
-NS_METHOD
-nsScriptableInputStream::Create(nsISupports *aOuter, REFNSIID aIID, void **aResult) {
-    if (aOuter) return NS_ERROR_NO_AGGREGATION;
-
-    nsScriptableInputStream *sis = new nsScriptableInputStream();
-    if (!sis) return NS_ERROR_OUT_OF_MEMORY;
-
-    NS_ADDREF(sis);
-    nsresult rv = sis->QueryInterface(aIID, aResult);
-    NS_RELEASE(sis);
-    return rv;
-}
Index: trunk/src/libs/xpcom18a4/xpcom/io/nsScriptableInputStream.h
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/io/nsScriptableInputStream.h	(revision 102317)
+++ 	(revision )
@@ -1,71 +1,0 @@
-/* -*- Mode: IDL; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
-/* ***** BEGIN LICENSE BLOCK *****
- * Version: MPL 1.1/GPL 2.0/LGPL 2.1
- *
- * The contents of this file are subject to the Mozilla Public License Version
- * 1.1 (the "License"); you may not use this file except in compliance with
- * the License. You may obtain a copy of the License at
- * http://www.mozilla.org/MPL/
- *
- * Software distributed under the License is distributed on an "AS IS" basis,
- * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
- * for the specific language governing rights and limitations under the
- * License.
- *
- * The Original Code is mozilla.org code.
- *
- * The Initial Developer of the Original Code is
- * Netscape Communications Corporation.
- * Portions created by the Initial Developer are Copyright (C) 1998
- * the Initial Developer. All Rights Reserved.
- *
- * Contributor(s):
- *
- * Alternatively, the contents of this file may be used under the terms of
- * either of the GNU General Public License Version 2 or later (the "GPL"),
- * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
- * in which case the provisions of the GPL or the LGPL are applicable instead
- * of those above. If you wish to allow use of your version of this file only
- * under the terms of either the GPL or the LGPL, and not to allow others to
- * use your version of this file under the terms of the MPL, indicate your
- * decision by deleting the provisions above and replace them with the notice
- * and other provisions required by the GPL or the LGPL. If you do not delete
- * the provisions above, a recipient may use your version of this file under
- * the terms of any one of the MPL, the GPL or the LGPL.
- *
- * ***** END LICENSE BLOCK ***** */
-
-#ifndef ___nsscriptableinputstream___h_
-#define ___nsscriptableinputstream___h_
-
-#include "nsIScriptableInputStream.h"
-#include "nsIInputStream.h"
-#include "nsCOMPtr.h"
-
-#define NS_SCRIPTABLEINPUTSTREAM_CID        \
-{ 0x7225c040, 0xa9bf, 0x11d3, { 0xa1, 0x97, 0x0, 0x50, 0x4, 0x1c, 0xaf, 0x44 } }
-
-#define NS_SCRIPTABLEINPUTSTREAM_CONTRACTID "@mozilla.org/scriptableinputstream;1"
-#define NS_SCRIPTABLEINPUTSTREAM_CLASSNAME "Scriptable Input Stream"
-
-class nsScriptableInputStream : public nsIScriptableInputStream {
-public:
-    // nsISupports methods
-    NS_DECL_ISUPPORTS
-
-    // nsIScriptableInputStream methods
-    NS_DECL_NSISCRIPTABLEINPUTSTREAM
-
-    // nsScriptableInputStream methods
-    nsScriptableInputStream() {};
-
-    static NS_METHOD
-    Create(nsISupports *aOuter, REFNSIID aIID, void **aResult);
-
-private:
-    ~nsScriptableInputStream() {};
-
-    nsCOMPtr<nsIInputStream> mInputStream;
-};
-
-#endif // ___nsscriptableinputstream___h_